#!/usr/bin/perl -w
#
# GTKSubEditor
#
# gss_callbacks.pl
# Callbacks to interface and some interface parts.
#
# Copyright (c) 2005 Joni Valtanen
# GNU General Public Licence v2
#
use Glib qw(TRUE FALSE);
use strict;

# to the about window
my $about_window;
my $about_button;
my $about_text;
my $about_table;

my $prefs_window;
my $prefs_table;
my $prefs_button_ok;
my $prefs_button_c;
my $prefs_check_mplayer;
my $prefs_text_import_fps;

$main::prefs_spin_import_fps=0;
$main::prefs_adj_mplayer=0;
@main::subtitles = ();

my $file_dialog;

my $copy="GTKSubEditor v$main::version

Copyright (c) 2005 Joni Valtanen
GNU General Public Licence v2";

#my $data;
#my $data={0,0};

$main::import_fps=25;
$main::use_mplayer=1;

$main::import_filename="/tmp/gsubeditor-imported.sub";
$main::tmp_filename="/tmp/gsubeditor-tmp1.sub";
$main::tmp2_filename="/tmp/gsubeditor-tmp2.sub";
$main::orig_filename="";
$main::tmp_col=0;
$main::lines=0;

sub readFileToCList
{
  my ($fn) = @_;
  print "$fn\n";


  my $i=0;

  @main::subtitles = ();
  $main::model->clear;

  open IFILE, "$fn" or die("Couldn't open $fn\n") ;
  while ($main::test = readline(IFILE))
  {
    $main::line = $main::test;
	 @main::line_t1 = split(/}/, $main::line);
	  @main::line_t2 = split(/{/, $main::line_t1[0]);
	  @main::line_t3 = split(/{/, $main::line_t1[1]);

          $main::substart[$i] = $main::line_t2[1];
	  $main::substop[$i] = $main::line_t3[1];
	  $main::subs[$i++] = $main::line_t1[2];
        }
	$i=0;
	while($main::substart[$i])
	  {
#	   $main::clist_subs->append( ($main::substart[$i], $main::substop[$i], $main::subs[$i] ));
#	    push @main::subtitles,     { start => $main::substart[$i], end=> $main::substop[$i], subtitle => $main::subs[$i], },;
	    $main::subtitles[$i]{start} = $main::substart[$i];
	    $main::subtitles[$i]{end} = $main::substop[$i];
	    $main::subtitles[$i]{subtitle} = $main::subs[$i];

      $main::model->set ($main::model->append,
		   0, $main::substart[$i],
		   1, $main::substop[$i],
		   2, $main::subs[$i],
		   3, TRUE,
      );
	   #  print "{$main::substart[$main::i]}{$main::substop[$main::i]}$main::subs[$main::i]\n";
	    $i++;
	}
  $main::lines=$i;
       close(IFILE);
#	$main::shift_item->set_sensitive(1);
	$main::button_shift->set_sensitive(1);
	$main::button_convert->set_sensitive(1);

}

sub quitProgram
{
  $main::window->destroy;
  return 0;
}

sub delete_event
  {
    $main::window->destroy;
    return TRUE;

  }

sub cell_edited {
  my ($cell, $path_string, $new_text, $model) = @_;

  my $path = Gtk2::TreePath->new_from_string ($path_string);
  my $column = $cell->get_data ("column");
  my $iter = $model->get_iter ($path);

  $main::button_edit_apply->set_sensitive(1);
  if ($column == 0)
    {
      my $i = ($path->get_indices)[0];
      $main::subtitles[$i]{start} = $new_text;
      $model->set ($iter, $column, $main::subtitles[$i]{start});

  }
  elsif ($column == 1)
    {
      my $i = ($path->get_indices)[0];
      $main::subtitles[$i]{end} = $new_text;
      $model->set ($iter, $column, $main::subtitles[$i]{end});
  }
  elsif ($column == 2)
  {
      my $i = ($path->get_indices)[0];
      $main::subtitles[$i]{subtitle} = $new_text;
      $model->set ($iter, $column, $main::subtitles[$i]{subtitle});
  }
}

sub fileOpenOK
{
 	# gots selected file
#  system("rm $main::tmp_filename");
#  system("rm $main::tmp2_filename");

 	$main::filename = $file_dialog->get_filename();
	$file_dialog->destroy();

        $main::orig_filename = $main::filename;
	$main::label_filename->set_text($main::filename);
	
	&readFileToCList($main::filename);
	return 0;
}

sub fileImportOK
{
  my $line;
  my $pwd=$ENV{'PWD'};
  print "$pwd";

#  system("rm $main::tmp_filename");
#  system("rm $main::tmp2_filename");

 	# gots selected file
 	$main::filename = $file_dialog->get_filename();
	$file_dialog->destroy();
        chdir "/tmp";
	system("mplayer /dev/zero -rawvideo on:pal:fps=$main::importfps -vc null -vo null -noframedrop -benchmark -sub \"$main::filename\" -dumpmicrodvdsub&");
	system("sleep 1 && killall mplayer");
        system("mv ./dumpsub.txt $main::import_filename");
        chdir "$pwd";
        $main::filename = $main::import_filename;
        $main::orig_filename = $main::filename;
	$main::label_filename->set_text($main::filename);
	&readFileToCList($main::filename);
	return 0;
}

sub fileSaveOK
{
 	# gots selected file
 	$main::filename = $file_dialog->get_filename();
	$file_dialog->destroy();

        $main::orig_filename = $main::filename;
	system("cp $main::tmp_filename \"$main::filename\"");

	return 0;
}

sub fileReread
{
  $main::filename=$main::orig_filename;
  &readFileToCList($main::orig_filename);
  return 0;
}

sub fileC
{
 	# gots selected file
	$file_dialog->destroy();
	return 0;
}

sub fileOpen
{
	$file_dialog = new Gtk2::FileSelection("Open subtitle");
	$file_dialog->complete( "*.sub" );
	$file_dialog->ok_button->signal_connect( "clicked", \&fileOpenOK, $file_dialog );
	$file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

	$file_dialog->show();

	return 0;
}

sub fileImport
{
	$file_dialog = new Gtk2::FileSelection("Import subtitle");
	$file_dialog->complete( "*.[srt|sub]" );
	$file_dialog->ok_button->signal_connect( "clicked", \&fileImportOK, $file_dialog );
	$file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );
	$file_dialog->show();
  print "Import\n";
	return 0;
}

sub fileSave
{
	$file_dialog = new Gtk2::FileSelection("Save subtitle");
	$file_dialog->complete( "*.sub" );
	$file_dialog->ok_button->signal_connect( "clicked", \&fileSaveOK, $file_dialog );
	$file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

	$file_dialog->show();
	return 0;
}

sub about
{

	# creates about window
	$about_window = new Gtk2::Window("toplevel");
	$about_table = new Gtk2::Table(2,2);
	$about_button = new Gtk2::Button("OK");
	$about_text = new Gtk2::Label($copy);

	$about_window->set_title("About GTKSubEditor $main::version");
	$about_window->set_default_size(250,70);
	$about_window->signal_connect( "delete_event", \&closeAbout );
	$about_button->signal_connect( "clicked", \&closeAbout );

        $about_table->attach_defaults( $about_text, 0, 1 , 0, 1 );
        $about_table->attach_defaults( $about_button, 0, 1 , 1, 2 );
	$about_table->set_border_width(4);
	$about_table->show();

	$about_text->show();

	$about_button->show();
	$about_button->set_border_width(4);

	$about_window->set_modal( 1 );
	$about_window->add($about_table);

	$about_window->show();
	return 0;
}

sub preferences
{
	# creates about window
	$prefs_window = new Gtk2::Window("toplevel");

	$prefs_table = new Gtk2::Table(2,3);

	$prefs_button_ok = new Gtk2::Button("OK");
	$prefs_button_c = new Gtk2::Button("Cancel");
	
	$prefs_check_mplayer = new Gtk2::CheckButton("MPlayer installed (required for importing)");
	$prefs_text_import_fps = new Gtk2::Label("Import FPS:");

#	$prefs_radio_mplayer = new Gtk2::Label("MPlayer intalled:");
	$main::prefs_adj_import_fps = new Gtk2::Adjustment( 0,
                            1.0,
                            100,
                            0.1,
                            1,
                            10 );

	$main::prefs_spin_import_fps = new Gtk2::SpinButton($main::prefs_adj_import_fps, 1.0, 3);

	$prefs_window->set_title("Prefs GTKSubEditor $main::version");
	$prefs_window->set_default_size(250,70);

	$prefs_window->signal_connect( "delete_event", \&closePrefs );
	$prefs_button_c->signal_connect( "clicked", \&closePrefs );
	$prefs_button_ok->signal_connect( "clicked", \&setPrefs );

        $prefs_table->attach_defaults( $prefs_check_mplayer, 1, 2 , 0, 1 );

        $prefs_table->attach_defaults( $prefs_text_import_fps, 0, 1 , 1, 2 );
        $prefs_table->attach_defaults( $main::prefs_spin_import_fps, 1, 2 , 1, 2 );

        $prefs_table->attach_defaults( $prefs_button_ok, 0, 1 , 2, 3 );
        $prefs_table->attach_defaults( $prefs_button_c, 1, 2 , 2, 3 );
	$prefs_table->set_border_width(4);
	$prefs_table->show();

	$prefs_check_mplayer->show();
	$prefs_text_import_fps->show();

	$prefs_button_c->show();
	$prefs_button_c->set_border_width(4);
	$prefs_button_ok->show();
	$prefs_button_ok->set_border_width(4);

	$main::prefs_spin_import_fps->show();
	$main::prefs_spin_import_fps->set_value($main::importfps);
	
	if($main::use_mplayer==1)
	  {
	    $prefs_check_mplayer->set_active(1);
	  }
	else
	  {
	    $prefs_check_mplayer->set_active(0);
	  }
	$prefs_window->set_modal( 1 );
	$prefs_window->add($prefs_table);

	$prefs_window->show();
	return 0;
}

sub closeAbout
{
	$about_window->destroy();
	return 0;
}

sub closePrefs
{
	$prefs_window->destroy();
	return 0;
}

sub setPrefs
{

	$main::importfps = $main::prefs_spin_import_fps->get_value();
	$main::use_mplayer = $prefs_check_mplayer->get_active;
	$prefs_window->destroy();
	&saveConfig();
	if($main::use_mplayer)
	  {
	    $main::import_item->set_sensitive(1);
	  }
	else
	  {
	    $main::import_item->set_sensitive(0);
	  }
	return 0;
}

sub shifting
{
  my $time = $main::adj_time->value;
  my $start = $main::adj_start->value;
  my $end = $main::adj_end->value;
  my $line;

  print "Shifting ;)\n";
  if( ($main::filename) && ( $time != 0 ) )
  {
    &cpMvSubFile();
    if($time<0)
    {
      $time = -$time;
      $line = "./subshift.pl -t $time -s $start -e $end -i $main::filename -o $main::tmp_filename -d";
    }
    else
    {
      $line = "./subshift.pl -t $time -s $start -e $end -i $main::filename -o $main::tmp_filename";
    }
    print "$line\n";
    system($line);

    $main::filename = $main::tmp_filename;
    &readFileToCList($main::filename);

    $main::reread_item->set_sensitive(1);
    $main::save_item->set_sensitive(1);
  }

  return 0;
}

sub cpMvSubFile
{
#  system("touch $main::tmp_filename");
    if(($main::filename eq $main::tmp2_filename))
      {
	system("mv $main::filename $main::tmp2_filename");
      }
    else
      {
	system("cp -R \"$main::filename\" $main::tmp2_filename");
      }
    $main::filename = $main::tmp2_filename;
}

sub select_row
{
    my ( $widget, $row, $column, $event, @data ) = @_;

    $main::text_start = $widget->get_text( $column, 0 );
    $main::text_end = $widget->get_text( $column, 1 );
    $main::text_text = $widget->get_text( $column, 2 );

    $main::tmp_col=$column;
    $main::spin_edit_fs->set_value($main::text_start);
    $main::spin_edit_fe->set_value($main::text_end);
    $main::entry_sub->set_text($main::text_text);
    $main::button_edit_ok->set_sensitive(1);

}


sub toStart
{
  my ($widget, $treeview) = @_;
  my $model = $treeview->get_model;
  my $selection = $treeview->get_selection;

  my $iter = $selection->get_selected;
  if ($iter) {
      my $path = $model->get_path ($iter);
      my $i = ($path->get_indices)[0];
      $main::text_start=$main::subtitles[$i]{start};
  }

  $main::adj_start->set_value($main::text_start);
  return 0;
}

sub toEnd
{
  my ($widget, $treeview) = @_;
  my $model = $treeview->get_model;
  my $selection = $treeview->get_selection;

  my $iter = $selection->get_selected;
  if ($iter) {
      my $path = $model->get_path ($iter);
      my $i = ($path->get_indices)[0];
      $main::text_end=$main::subtitles[$i]{end};
  }
  $main::adj_end->set_value( $main::text_end);
	return 0;
}

sub convertFPS
{
    my $line;
    my $ofps = $main::spin_ofps->get_value();
    my $nfps = $main::spin_nfps->get_value();

    &cpMvSubFile();

    $line = "./setsubfps.pl -f $ofps -n $nfps -i $main::filename -o $main::tmp_filename";

    print "$line\n";
    system($line);

    $main::filename = $main::tmp_filename;
    &readFileToCList($main::filename);

    $main::reread_item->set_sensitive(1);
    $main::save_item->set_sensitive(1);
    return 0;
}

sub oFPS
  {
    my ( $widget, $event, @data ) = @_;
    $main::spin_ofps->set_value($event);
    return 0;

  }
sub nFPS
  {
    my ( $widget, $event, @data ) = @_;
    $main::spin_nfps->set_value($event);
    return 0;

  }

#sub setEditSubtitle
#{
#    my $col = $main::tmp_col;
#    my $start = $main::spin_edit_fs->get_value_as_int();
#    my $end = $main::spin_edit_fe->get_value_as_int();
#    my $text = $main::entry_sub->get_text();
#    my @subtext = ($start,$end,$text);
#    my $line;

#    print "$col\n";

    #replace $cols line with this line
#    $line = "{$start}{$end}$text\n";

#    print "$line";
#    print "$subtext[0] $subtext[1] $subtext[2]";

#    $main::clist_subs->remove( $col );
#    $main::clist_subs->insert( $col, @subtext );

#    $main::reread_item->set_sensitive(1);

#}

sub applyEditSubtitle
{
    my $start;
    my $end;
    my $text;
    my $line="";
    my $oldout;

    open $oldout, ">&STDOUT" or die "Can't duplicate STDOUT: $!";

    #next should write to the file
    &cpMvSubFile();

    open STDOUT, ">$main::tmp_filename" or die("Couldn't open $main::tmp_filename\n") ;

    for my $row (0..$main::lines-1)
    {
      $start = $main::subtitles[$row]{start};
      $end = $main::subtitles[$row]{end};
      $text = $main::subtitles[$row]{subtitle};
      $line = "{$start}{$end}$text";
      print "$line";
    }

    close STDOUT;
    open STDOUT, ">&", $oldout or die "Can't restore old STDOUT: $!";

    $main::filename = $main::tmp_filename;
    &readFileToCList($main::filename);

    $main::save_item->set_sensitive(1);
    $main::button_edit_apply->set_sensitive(0);


}

1;
