#!/usr/bin/perl -w
#
# GTKSubEditor
#
# gss_interface.pl
# Creates interface
#
# Copyright (c) 2005 Joni Valtanen
# GNU General Public Licence v2
#
#package store_list;
use strict;

# main window
$main::window=0;

my $notebook;
my $frame_subfile;

my $table_main;
my $table_filename;
my $table_convert;
my $table_shift;
my $table_all;

# buttons nb1
$main::button_shift=0;
$main::button_start=0;
$main::button_end=0;
my $button_quit;

# buttons nb2
$main::button_convert=0;

#spins nb2
$main::adj_ofps=0;
$main::adj_nfps=0;
$main::spin_ofps=0;
$main::spin_nfps=0;

#optionmenu nb2
my $option_ofps;
my $option_nfps;
my $option_ofps_menu;
my $option_nfps_menu;

my $ofps29_item;
my $ofps25_item;
my $ofps23_item;

my $nfps29_item;
my $nfps25_item;
my $nfps23_item;


#menus
my $menu_bar;
my $file_item;
my $edit_item;
my $help_item;

my $file_menu;
my $open_item;
$main::import_item=0;
$main::reread_item=0;
$main::save_item=0;
my $quit_item;

my $tools_menu;
$main::prefs_item=0;

my $help_menu;
my $about_item;

#labels
my $label_notebook1;
my $label_notebook2;
#my $label_notebook3;

my $label_name;
my $label_start;
my $label_end;
my $label_time;
my $label_subs;
$main::label_filename=0;

my $label_ofps;
my $label_nfps;

#my $label_edit_fs;
#my $label_edit_fe;
#my $label_edit_sub;

my $label_frames0;
my $label_frames1;
my $label_frames2;

my @data;

$main::button_edit_apply = 0;

#adjusters
$main::adj_time=0;
$main::adj_start=0;
$main::adj_end=0;

#spinbuttons
my $spin_time;
my $spin_start;
my $spin_end;

# my $start;


my $scrolled_window;
$main::clist_subs = 0;

my $false = 0;
my $true = 1;

sub createGUI
{

	# basic stings
	$main::window = new Gtk2::Window( "toplevel" );

	$frame_subfile = new Gtk2::Frame( "Subtitle file" );

	$table_main = new Gtk2::Table( 4, 2, $true );
	$table_filename = new Gtk2::Table( 1, 1, $true );
	$table_shift = new Gtk2::Table( 5, 4, $true );
	$table_convert = new Gtk2::Table( 3, 3, $true );
	$table_all = new Gtk2::Table( 2, 4, $true );

	$main::window->set_default_size(400,400);
	
	#notebook
	$notebook = new Gtk2::Notebook();

	# nb1 buttons
	$main::button_shift = new Gtk2::Button( "Shift" );
	$main::button_start = new Gtk2::Button( "From selection" );
	$main::button_end = new Gtk2::Button( "From selection" );
	$button_quit = new Gtk2::Button( "Quit" );

	# nb2 buttons
	$main::button_convert = new Gtk2::Button( "Convert FPS" );

	# nb2 option menus
	$option_ofps = new Gtk2::OptionMenu();
	$option_nfps = new Gtk2::OptionMenu();
	
	# menus
	$menu_bar = new Gtk2::MenuBar();
	$file_item = new Gtk2::MenuItem( "_File" );
	$edit_item = new Gtk2::MenuItem( "_Edit" );
	$help_item = new Gtk2::MenuItem( "_Help" );

	$file_menu = new Gtk2::Menu();
	$open_item = new Gtk2::MenuItem( "_Open" );
	$main::import_item = new Gtk2::MenuItem( "_Import" );
	$main::reread_item = new Gtk2::MenuItem( "_Reload..." );
	$main::save_item = new Gtk2::MenuItem( "Save _As" );
	$quit_item = new Gtk2::MenuItem( "_Quit" );

	$tools_menu = new Gtk2::Menu();
	$main::prefs_item = new Gtk2::MenuItem( "_Prefs" );

	$help_menu = new Gtk2::Menu();
	$about_item = new Gtk2::MenuItem( "_About" );

	# option menus nb2
	$option_ofps_menu = new Gtk2::Menu();
	$option_nfps_menu = new Gtk2::Menu();

	$ofps23_item = new Gtk2::MenuItem( "23.976" );
	$ofps25_item = new Gtk2::MenuItem( "25" );
	$ofps29_item = new Gtk2::MenuItem( "29" );

	$nfps23_item = new Gtk2::MenuItem( "23.976" );
	$nfps25_item = new Gtk2::MenuItem( "25" );
	$nfps29_item = new Gtk2::MenuItem( "29" );

	$option_ofps_menu->append( $ofps23_item );
	$option_ofps_menu->append( $ofps25_item );
	$option_ofps_menu->append( $ofps29_item );

	$option_nfps_menu->append( $nfps23_item );
	$option_nfps_menu->append( $nfps25_item );
	$option_nfps_menu->append( $nfps29_item );


	# labels
	$label_notebook1 = new Gtk2::Label("Shift");;
	$label_notebook2 = new Gtk2::Label("Convert");;
#	$label_notebook3 = new Gtk2::Label("Edit");;

	$main::label_filename = new Gtk2::Label("Not loaded.");
	$label_name = new Gtk2::Label("Subfile:");
	$label_start = new Gtk2::Label("Start:");
	$label_end = new Gtk2::Label("End:");
	$label_time = new Gtk2::Label("Time:");

#	$label_subs = new Gtk2::Label("Subs:");

	$label_ofps = new Gtk2::Label("Original FPS:");
	$label_nfps = new Gtk2::Label("New FPS:");

#	$label_edit_fs = new Gtk2::Label("Start:");
#	$label_edit_fe = new Gtk2::Label("End:");
#	$label_edit_sub = new Gtk2::Label("Sub:");

	$label_frames0 = new Gtk2::Label("from frame");
	$label_frames1 = new Gtk2::Label("to frame");
	$label_frames2 = new Gtk2::Label("frames");


	$label_name->set_justify( "left" );
	$label_start->set_justify( "left" );
	$label_end->set_justify( "left" );
	$label_time->set_justify( "left" );
	
	#adjustments to spin bittons
	$main::adj_time = new Gtk2::Adjustment( 0,
                            -999999,
                            999999,
                            1,
                            1,
                            10 );

	$main::adj_start = new Gtk2::Adjustment( 0,
                            0,
                            999999,
                            1,
                            1,
                            10 );

	$main::adj_end = new Gtk2::Adjustment( 0,
                            0,
                            999999,
                            1,
                            1,
                            10 );

	#nb2 adjustments
	$main::adj_ofps = new Gtk2::Adjustment( 0,
                            1.0,
                            100,
                            0.1,
                            1,
                            10 );

	$main::adj_nfps = new Gtk2::Adjustment( 0,
                            1.0,
                            100,
                            0.1,
                            1,
                            10 );

	#nb3 adjustments
#	$main::adj_edit_fs = new Gtk2::Adjustment( 0,
#                            1,
#                            999999,
#                            1,
#                            1,
#                            10 );

#	$main::adj_edit_fe = new Gtk2::Adjustment( 0,
#                            1,
#                            999999,
#                            1,
#                            1,
#                            10 );
	#spinbuttons
	$spin_start = new Gtk2::SpinButton($main::adj_start, 1.0, 0);
	$spin_end = new Gtk2::SpinButton($main::adj_end, 1.0, 0);
	$spin_time = new Gtk2::SpinButton($main::adj_time, 1.0, 0);

	#nb2 spins
	$main::spin_ofps = new Gtk2::SpinButton($main::adj_ofps, 1.0, 3);
	$main::spin_nfps = new Gtk2::SpinButton($main::adj_nfps, 1.0, 3);
	$main::spin_ofps->set_value( "23.976" );
	$main::spin_nfps->set_value( "25.00" );

	$main::button_edit_apply = new Gtk2::Button( "Apply edited" );

	# list	
	$scrolled_window = new Gtk2::ScrolledWindow( undef, undef );
	$scrolled_window->set_policy( 'automatic', 'always' );
	$scrolled_window->show();

#	$main::clist_subs = Gtk2::Widget->new("Gtk2::CList");
#	$main::clist_subs = new_with_titles Gtk2::CList( ("Start","Stop","Subtitle") );

	$main::model = Gtk2::ListStore->new ('Glib::Uint', 'Glib::Uint', 'Glib::String', 'Glib::Boolean');
	$main::clist_subs = Gtk2::TreeView->new ($main::model);
	$main::clist_subs->set_rules_hint (TRUE);
#	$main::clist_subs->set_search_column (2);

	my $renderer = Gtk2::CellRendererText->new;
	$renderer->set_data (column => 0);
	$renderer->signal_connect (edited => \&cell_edited, $main::model);

#	my $column = Gtk2::TreeViewColumn->new_with_attributes
	$main::clist_subs->insert_column_with_attributes (-1, "Start",
						     $renderer,
						     text => 0,
							    editable => 3
							       );
#	$column->set_sort_column_id (0);
#	$main::clist_subs->append_column ($column);

	# column for severities
	$renderer = Gtk2::CellRendererText->new;
	$renderer->set_data (column => 1);
	$renderer->signal_connect (edited => \&cell_edited, $main::model);
#	$column = Gtk2::TreeViewColumn->new_with_attributes
	  $main::clist_subs->insert_column_with_attributes (-1,"Stop",
						       $renderer,
						       text => 1,
							    editable => 3
							    );
#	$column->set_sort_column_id (1);
#	$main::clist_subs->append_column ($column);

	# column for description
	$renderer = Gtk2::CellRendererText->new;
	$renderer->set_data (column => 2);

	$renderer->signal_connect (edited => \&cell_edited, $main::model);
#	$column = Gtk2::TreeViewColumn->new_with_attributes
	$main::clist_subs->insert_column_with_attributes (-1,"Subtitle",
						       $renderer,
						       text => 2,
							    editable => 3
							    );



#	$column->set_sort_column_id (2);
#	$main::clist_subs->append_column ($column);



#	$main::clist_subs->set_selection_mode( "single" );
#	$main::clist_subs->set_rules_hint (TRUE);
	# File menu
	$file_menu->append( $open_item );
	$file_menu->append( $main::import_item );
	$file_menu->append( $main::reread_item );
	$file_menu->append( $main::save_item );
	$file_menu->append( $quit_item );

	$file_item->show();
	$file_item->set_submenu( $file_menu );

	$file_menu->show();

	#show option menu
	$option_ofps->set_menu($option_ofps_menu);
	$option_nfps->set_menu($option_nfps_menu);

	$option_ofps->set_history( 0 );
	$option_nfps->set_history( 1 );

	#tools menu
	$tools_menu->append( $main::prefs_item );
	$edit_item->show();
	$edit_item->set_submenu( $tools_menu );

	# Help menu
	$help_menu->append( $about_item );

	$help_item->show();
	$help_item->set_submenu( $help_menu );

	$menu_bar->show();

	# signal for menus
	$open_item->signal_connect( 'activate', \&fileOpen );
	$main::import_item->signal_connect( 'activate', \&fileImport );
	$main::reread_item->signal_connect( 'activate', \&fileReread );
	$main::save_item->signal_connect( 'activate', \&fileSave );
	$quit_item->signal_connect( 'activate', \&quitProgram );
	$main::prefs_item->signal_connect( 'activate', \&preferences );
	$about_item->signal_connect( 'activate', \&about );

	#signals to nb2 option menu
	$ofps25_item->signal_connect( 'activate', \&oFPS, "25" );
	$ofps23_item->signal_connect( 'activate', \&oFPS, "23.976" );
	$ofps29_item->signal_connect( 'activate', \&oFPS, "29" );

	$nfps25_item->signal_connect( 'activate', \&nFPS, "25" );
	$nfps23_item->signal_connect( 'activate', \&nFPS, "23.976" );
	$nfps29_item->signal_connect( 'activate', \&nFPS, "29" );

	# build nb2 option menu
#	$option_ofps_menu->show();
#	$option_nfps_menu->show();

	$ofps23_item->show();
	$ofps25_item->show();
	$ofps29_item->show();

	$nfps23_item->show();
	$nfps25_item->show();
	$nfps29_item->show();

	# build menu bar
	$open_item->show();
	$main::import_item->show();
	$main::reread_item->show();
	$main::save_item->show();
	$quit_item->show();
	$main::reread_item->set_sensitive(0);
	$main::save_item->set_sensitive(0);

	$main::prefs_item->show();
#	$main::prefs_item->set_sensitive(0);

	$about_item->show();


	# signals window
	$button_quit->signal_connect( "clicked", \&quitProgram );
	$main::button_start->signal_connect( "clicked", \&toStart, $main::clist_subs );
	$main::button_end->signal_connect( "clicked", \&toEnd, $main::clist_subs );
	$main::button_shift->signal_connect( "clicked", \&shifting );
	$main::button_convert->signal_connect( "clicked", \&convertFPS);
	$main::window->signal_connect( "delete_event" => \&delete_event );
	$main::window->signal_connect(destroy => sub { Gtk2->main_quit; });

	$data[0] = $main::clist_subs;
#        $main::clist_subs->signal_connect( "select_row", \&select_row, @data );
#        $main::model->signal_connect( "select_row", \&select_row, @data );

#	$main::button_edit_ok->signal_connect( "clicked", \&setEditSubtitle);
	$main::button_edit_apply->signal_connect( "clicked", \&applyEditSubtitle);
	
	#notebook
##	$notebook->prepend_page( $table_edit, $label_notebook3);
	$notebook->prepend_page( $table_convert, $label_notebook2);
	$notebook->prepend_page( $table_shift, $label_notebook1 );
	$notebook->show();

	# table
	my $xoptions = "shrink";
	my $yoptions = "shrink";
	my $xpadding = 0;
	my $ypadding = 0;

	$scrolled_window->add( $main::clist_subs );

	# table shift
        $table_shift->set_homogeneous( $false);

	$table_shift->attach( $label_start, 0, 1, 0, 1, $xoptions, $yoptions, $xpadding, $ypadding );
	$table_shift->attach( $spin_start, 1, 2, 0, 1, "fill", $yoptions, $xpadding, $ypadding );
	$table_shift->attach( $label_frames0, 2, 3, 0, 1, $xoptions, $yoptions, $xpadding, $ypadding );
	$table_shift->attach( $main::button_start, 3, 4, 0, 1, $xoptions, $yoptions, $xpadding, $ypadding );

	$table_shift->attach( $label_end, 0, 1, 1, 2, $xoptions, $yoptions, $xpadding, $ypadding );
	$table_shift->attach( $spin_end, 1, 2, 1, 2, "fill", $yoptions, $xpadding, $ypadding );
	$table_shift->attach( $label_frames1, 2, 3, 1, 2, $xoptions, $yoptions, $xpadding, $ypadding );
	$table_shift->attach( $main::button_end, 3, 4, 1, 2, $xoptions, $yoptions, $xpadding, $ypadding );

	$table_shift->attach( $label_time, 0, 1, 2, 3, $xoptions, $yoptions, $xpadding, $ypadding );
	$table_shift->attach( $spin_time, 1, 2, 2, 3, "fill", $yoptions, $xpadding, $ypadding );
	$table_shift->attach( $label_frames2, 2, 3, 2, 3, $xoptions, $yoptions, $xpadding, $ypadding );

	$table_shift->attach( $main::button_shift, 0, 4, 3, 4, "fill", $yoptions, $xpadding, $ypadding );
	$table_shift->set_border_width(4);
#	$frame_shift->add($table_shift);

	# table convert
        $table_convert->set_homogeneous( $false);
	$table_convert->attach( $label_ofps, 0, 1, 0, 1, $xoptions, $yoptions, $xpadding, $ypadding );
	$table_convert->attach( $main::spin_ofps, 1, 2, 0, 1, ["expand","fill"], $yoptions, $xpadding, $ypadding );
	$table_convert->attach( $option_ofps, 2,3,0,1,["expand","fill"], $yoptions, $xpadding, $ypadding );

	$table_convert->attach( $label_nfps, 0, 1, 1, 2, $xoptions, $yoptions, $xpadding, $ypadding );
	$table_convert->attach( $main::spin_nfps, 1, 2, 1, 2,  "fill", $yoptions, $xpadding, $ypadding );
	$table_convert->attach( $option_nfps, 2,3,1,2,["expand","fill"], $yoptions, $xpadding, $ypadding );

	$table_convert->attach( $main::button_convert, 0, 3, 2, 3, "fill", $yoptions, $xpadding, $ypadding );
	$table_convert->set_border_width(4);

	# table edit
#        $table_edit->set_homogeneous( $false);

#	$table_edit->attach( $label_edit_fs, 0, 1, 0, 1, $xoptions, $yoptions, $xpadding, $ypadding );
#	$table_edit->attach( $main::spin_edit_fs, 1, 2, 0, 1, ["expand","fill"], $yoptions, $xpadding, $ypadding );

#	$table_edit->attach( $label_edit_fe, 0, 1, 1, 2, $xoptions, $yoptions, $xpadding, $ypadding );
#	$table_edit->attach( $main::spin_edit_fe, 1, 2, 1, 2,  "fill", $yoptions, $xpadding, $ypadding );

#	$table_edit->attach( $label_edit_sub, 0, 1, 2, 3, "fill", $yoptions, $xpadding, $ypadding );
#	$table_edit->attach( $main::entry_sub, 1, 2, 2, 3, "fill", $yoptions, $xpadding, $ypadding );
#	$table_edit->attach( $main::button_edit_ok, 0, 2, 3, 4, "fill", $yoptions, $xpadding, $ypadding );
#	$table_edit->attach( $main::button_edit_apply, 0, 2, 4, 5, "fill", $yoptions, $xpadding, $ypadding );

	$table_convert->set_border_width(4);


	# table all
        $table_all->set_homogeneous( $false );

	$frame_subfile->add( $main::label_filename ); #, 1, 2, 2, 3, "expand", $yoptions, $xpadding, $ypadding);
	$table_all->attach_defaults( $frame_subfile, 0, 2, 0, 1); #, "fill", $yoptions, $xpadding, $ypadding);
	$table_all->attach_defaults( $scrolled_window, 0, 2, 1, 3 );
	$table_all->attach( $main::button_edit_apply, 0, 2, 3, 4, "fill", $yoptions, $xpadding, $ypadding );
	$table_all->attach( $button_quit, 1, 2, 4, 5, "fill", $yoptions, $xpadding, $ypadding );
	$table_all->set_border_width(4);

	# table main
        $table_main->set_homogeneous( $false );

	$table_main->attach( $menu_bar, 0, 2, 0, 1, "fill", $yoptions, $xpadding, $ypadding);
	$table_main->attach( $notebook, 0, 2, 1, 2, "fill", $yoptions, $xpadding, $ypadding);
	$table_main->attach_defaults( $table_all, 0, 2, 3, 4);
#	$table_main->set_border_width(2);


	$menu_bar->append($file_item);	
	$menu_bar->append($edit_item);	
	$menu_bar->append($help_item);	

	$button_quit->show();

	$main::button_shift->show();
	$main::button_start->show();
	$main::button_end->show();
	$main::button_shift->set_sensitive(0);

	$main::button_convert->show();
	$main::button_convert->set_sensitive(0);

	$label_name->show();
	$main::label_filename->show();
	$label_start->show();
	$label_end->show();
	$label_time->show();

	$label_ofps->show();
	$label_nfps->show();
	$main::spin_ofps->show();
	$main::spin_nfps->show();

	$spin_start->show();
	$spin_end->show();
	$spin_time->show();

#	$label_edit_fs->show();
#	$label_edit_fe->show();

	$label_frames0->show();
	$label_frames1->show();
	$label_frames2->show();

	$main::clist_subs->show();

#	$label_edit_sub->show();
#	$main::entry_sub->show();
#	$main::button_edit_ok->show();
#	$main::button_edit_ok->set_sensitive(0);
	$main::button_edit_apply->show();
	$main::button_edit_apply->set_sensitive(0);

	if($main::use_mplayer)
	  {
	    $main::import_item->set_sensitive(1);
	  }
	else
	  {
	    $main::import_item->set_sensitive(0);
	  }

	$option_ofps->show();
	$option_nfps->show();
#	$frame_shift->show();
#	$frame_convert->show();
	$frame_subfile->show();

	$table_main->show();
	$table_filename->show();
	$table_shift->show();
	$table_convert->show();
#	$table_edit->show();
	$table_all->show();
	
	$main::window->set_border_width( 1 );
	$main::window->add( $table_main );
	$main::window->show();
}

1;
