#!/usr/bin/perl -w
#
# GTKSubEditor v0.7
# Graphical frontend to manage microdvd-files
#
# Copyright (c) 2005 Joni Valtanen
# GNU General Public Licence v2
#

use utf8;
use Gtk2 '-init';
use strict;

my $oldout;
my $config_dir;
my $config_file;
my @line_t1;
my @line_t2;
my $line;

$main::use_mplayer=0;
$main::importfps=25.0;

set_locale Gtk2;  # Locales
init Gtk2;        # Gtk-Perl

$main::version=0.4;
$main::version=0.6;

@main::subs = ();   #list to subtitles
@main::subs = ();

$main::filename="";
$main::filename="";

$main::shifttime=0;
$main::shifttime=0;

require "gss_callbacks.pl";
require "gss_interface.pl";

$config_dir = "$ENV{'HOME'}/.gsubeditor";
$config_file = "$config_dir\/config";

#read prefs
#if not .gsubeditor directory
if(!(-e $config_dir))
{
  system("mkdir $config_dir");
}

#if not config file
if(!(-e $config_file))
{
  &saveConfig();
}

open(IFILE, $config_file);
while ($line =  readline(IFILE)) {
  @line_t1 = split(/=/, $line);
  @line_t2 = split(/;/, $line_t1[1]);
  if($line_t1[0] eq "mplayer")
    {
      if($line_t2[0] eq "true")
	{
	  $main::use_mplayer=1;
	}
      else
	{
	  $main::use_mplayer=0;
	}
    }
  if($line_t1[0] eq "importfps")
    {
      if($line_t2[0])
	{
	  $main::importfps=$line_t2[0];
	}
    }
}
close(IFILE);

&createGUI();

main Gtk2;


exit (0);

#saves Configfile
sub saveConfig
{
  my $mp;
  if($main::use_mplayer)
    {
      $mp="true";
    }
  else
    {
      $mp="false";
    }

   open $oldout, ">&STDOUT" or die "Can't duplicate STDOUT: $!";
   open STDOUT, ">$config_file" or die("Couldn't open $config_file\n") ;

   $line = "mplayer=$mp;\nimportfps=$main::importfps;\n";
   print "$line";

   close STDOUT;
   open STDOUT, ">&", $oldout or die "Can't restore old STDOUT: $!";
}
